Subject: bug#62416: 30.0.50; Symbols skipped in the navigation in ruby-ts-mode

From: Yuan Fu <[email-masked]>
Date: Sun, 2 Apr 2023 15:34:54 -0700

> On Mar 30, 2023, at 2:32 AM, Dmitry Gutov <[email-masked]> wrote:
> 
> On 30/03/2023 10:47, Yuan Fu wrote:
> 
>>> However, there are still a lot of more things that need fixing.
>>> When point is on the left curly bracket in
>>> 
>>>   b = %Q{This is a "string"}
>>> 
>>> 'C-M-f' doesn't move to the right curly bracket.
>>> Also double quotes inside the string are not matched by 'C-M-f'.
>>> 
>>> In
>>> 
>>>   d = %(hello (nested) world)
>>> 
>>> 'C-M-f' doesn't move to the closing parens from opening parens.
>> Have someone fixed these two cases? Because when I tried to invoke
>> (treesit-forward-sexp), point moved to the closing bracket/paren.
> 
> From which position? When point is right before '{', it doesn't move in my testing. It does move when it was before '%'.

Ok, I see it. I’ll try to see what’s going on when I find some time. 

> 
>> Anyway, I just wonder if there’s any fundamental shortcoming with how
>> treesit-beginning/end-of-thing works?
> 
> I don't know. Seems like this method is good for a lot of things, but some fiddly details are going to be different from the default forward-sexp.
> 
> ruby-mode's sexp navigation is also not ideal in its own way, and it's been useful anyway.

One thing I noticed is that treesit-forward-sexp uses treesit-beginning/end-of-thing, which jumps out of the parent when there is no more siblings to go to. The default forward-sexp obviously doesn’t do this. Perhaps we should stay in the same level in tree-sitter-forward-sexp too. 

Yuan